
###############################
# CMPT 120: COURSE EXERCISE 7 #
###############################



# sort(L): takes a list L and returns this list in sorted
# (increasing) order using the function add_in_place(L,x)
# which was previously the "mystery" function

def sort(L):
  new_L = []
  for x in L:
    add_in_place(new_L, x)
  return new_L


# add_in_place(L, x): takes a *sorted* list L, and adds the
# element x at the position where it should be so that the
# the list be sorted; this function modifies L and does not
# return a result.

def add_in_place(L, x):    
  for i in range(len(L)):
    if L[i] > x:
      L.insert(i,x)
      return
  # if element was not inserted in the loop it must
  # be added at the end of the list
  L.insert(len(L), x)



# a lot of automatic tests

assert(sort([3,2,1]) == [1,2,3])
assert(sort([1,5,8,2,1]) == [1,1,2,5,8])
assert(sort([]) == [])
assert(sort([1,1,1]) == [1,1,1])
assert(sort([1]) == [1])
assert(sort([1,2,3]) == [1,2,3])
assert(sort([9,8,7,8,9]) == [7,8,8,9,9])
